<template>
  <div class="container-fluid">

    <!-- start page title -->
    <div class="row">
      <div class="col-12">
        <div class="page-title-box">
          <h4 class="page-title">Корзина</h4>
        </div>
      </div>
    </div>
    <!-- end page title -->

    <div class="row">
      <div class="col-12">
        <div class="card">
          <div class="card-body">
            <div class="row">
              <div class="col-lg-8">
                <div class="alert alert-success" role="alert" v-show="isSuccess">
                  <i class="mdi mdi-check-all mr-2"></i> Товар успешно заказан!
                </div>
                <div class="table-responsive">
                  <table class="table table-borderless table-centered mb-0">
                    <thead class="thead-light">
                    <tr>
                      <th>Товар</th>
                      <th>Цена</th>
                      <th>Размеры</th>
                      <th>Количество</th>
                      <th>Сумма</th>
                      <th style="width: 50px;"></th>
                    </tr>
                    </thead>
                    <tbody>
                    <template v-for="product in products">
                      <tr v-for="(size, index) in product.sizes">
                      <td :rowspan="countSizes(product.sizes)" v-if="index == 0">
                        <img src="/assets/images/products/product-1.png"alt="contact-img"
                             title="contact-img" class="rounded mr-3" height="48" />
                        <p class="m-0 d-inline-block align-middle font-16">
                          <a href="#" class="text-reset font-family-secondary">{{product.name}}</a>
                          <br>
                          <small><b>Color:</b> {{product.color}}
                          </small>
                        </p>
                      </td>
                      <td :rowspan="countSizes(product.sizes)" v-if="index == 0">
                        {{product.price}}
                      </td>
                      <td>
                        {{ size.title }}
                      </td>
                      <td>
                        <input type="number" min="0" :value="product.cart_sizes[size.value]" class="form-control" @change="currentSizes($event, product.id, size.value, size.stock)" :name="'size['+product.id+']['+size.value+']'" placeholder="Qty" style="width: 90px;">
                      </td>
                      <td :rowspan="countSizes(product.sizes)" v-if="index == 0">
                        {{product.total}}
                      </td>
                      <td :rowspan="countSizes(product.sizes)" v-if="index == 0">
                        <a href="javascript:void(0);" class="action-icon"> <i class="mdi mdi-delete"></i></a>
                      </td>
                      </tr>
                    </template>
                    </tbody>
                  </table>
                  <div class="card-box" style="text-align:center" v-if="status == 'empty'">
                    <div>Корзина пуста</div>
                  </div>
                </div> <!-- end table-responsive-->

                <!-- Add note input-->
                <div class="mt-3" v-if="false">
                  <label for="example-textarea">Добавьте заметку:</label>
                  <textarea class="form-control" id="example-textarea" rows="3" placeholder="Write some note.."></textarea>
                </div>

                <!-- action buttons-->
                <div class="row mt-4">
                  <div class="col-sm-6">
                    <NuxtLink :to="'/products'" class="btn text-muted d-none d-sm-inline-block btn-link font-weight-semibold">
                      <i class="mdi mdi-arrow-left"></i> Продолжить покупки </NuxtLink>
                  </div> <!-- end col -->
                  <div class="col-sm-6" v-if="status != 'empty'">
                    <div class="text-sm-right">
                      <a href="#" class="btn btn-danger" @click.prevent="sendOrder()"><i class="mdi mdi-cart-plus mr-1"></i> Заказать </a>
                    </div>
                  </div> <!-- end col -->
                </div> <!-- end row-->
              </div>
              <!-- end col -->

              <div class="col-lg-4">
                <div class="border p-3 mt-4 mt-lg-0 rounded">
                  <h4 class="header-title mb-3">Информация о заказе</h4>

                  <div class="table-responsive">
                    <table class="table mb-0">
                      <tbody>
                      <tr>
                        <td>Заказ на сумму :</td>
                        <td>{{ price_total }} р.</td>
                      </tr>
                      <tr>
                        <td>Скидка: </td>
                        <td>-{{ discount }} р.</td>
                      </tr>
                      <tr>
                        <th>Итого :</th>
                        <th>{{total}} р.</th>
                      </tr>
                      </tbody>
                    </table>
                  </div>
                  <!-- end table-responsive -->
                </div>

                <div class="alert alert-warning mt-3" role="alert" v-if="false">
                  Use coupon code <strong>UBTF25</strong> and get 25% discount !
                </div>

                <div class="input-group mt-3" v-if="false">
                  <input type="text" class="form-control form-control-light" placeholder="Coupon code"
                         aria-label="Recipient's username">
                  <div class="input-group-append">
                    <button class="btn btn-light" type="button">Применить</button>
                  </div>
                </div>

              </div> <!-- end col -->

            </div> <!-- end row -->
          </div> <!-- end card-body-->
        </div> <!-- end card-->
      </div> <!-- end col -->
    </div>
    <!-- end row -->

  </div> <!-- container -->
</template>

<script>
export default {
  name: "index",
  data(){
    return {
      price_total: 0,
      discount: 0,
      total: 0,
      products: {},
      sizes: {},
      currentSelectedSizes: {},
      status: 'empty',
      isSuccess: false,
    }
  },
  created () {
    this.$axios.get('/carts')
      .then(resp => {
          this.price_total = resp.data.price_total;
          this.discount = resp.data.discount;
          this.total = resp.data.total;
          this.products = resp.data.products;
          this.status = resp.data.status;
          this.getSizes();
      }).catch(function(){
      console.log('Error 123');
    });
  },
  computed:{
      isSuccess: function(){
        return this.isSucccess;
      }
  },
  methods:{
    getSizes(){
      for(let product in this.products){
        this.sizes[product] = {};
        for(let size in this.products[product].cart_sizes){
          this.sizes[product][size] = this.products[product].cart_sizes[size];
        }
      }
    },
     countSizes(sizes){
        return sizes.length;
     },
    currentSizes(el, product_id, size_value, stock)
    {

      // Проверить логику увеличения количества, учитывая уже заказанное количество и доступный ассортимено. Должна быть уже имеющееся количество + остаток в товаре
      if(stock > 0) {
        if (el.target.value > stock) {
          el.target.value = stock;
        } else if (el.target.value < 0 || el.target.value == '') {
          el.target.value = 0;
        }
      }else{
        if (el.target.value > this.sizes[product_id][size_value]) {
          el.target.value = this.sizes[product_id][size_value];
        } else if (el.target.value < 0 || el.target.value == '') {
          el.target.value = 0;
        }
      }

      this.products[product_id].cart_sizes[size_value] = el.target.value;

      this.products[product_id].total = 0;
      let total = 0;
      let product_discount = 0;

      for(let size in this.products[product_id].cart_sizes){
        total = total + this.products[product_id].price * this.products[product_id].cart_sizes[size];

        if(this.products[product_id].is_percent){
          product_discount = product_discount + (this.products[product_id].cart_sizes[size] * this.products[product_id].price * this.products[product_id].discount);
        }else{
          product_discount = product_discount + (this.products[product_id].cart_sizes[size] * this.products[product_id].discount);
        }
      }

      this.products[product_id].total = total;
      this.products[product_id].product_discount = product_discount;

      this.price_total = 0;
      this.discount = 0;

      for(let product in this.products){
        this.price_total = this.price_total + this.products[product].total;
        this.discount = this.discount + this.products[product].product_discount;
      }


      this.total = this.price_total - this.discount;

      if(product_id in this.currentSelectedSizes == false){
        this.currentSelectedSizes[product_id] = {};
      }
      if(el.target.value > 0){
         this.currentSelectedSizes[product_id][size_value] = {'value':el.target.value};
       }else if(this.currentSelectedSizes[product_id][size_value] && el.target.value == 0){
         delete this.currentSelectedSizes[product_id][size_value];
       }
    },
    sendOrder(){
       this.$axios.post('/orders/new', {'data':this.currentSelectedSizes})
      .then(resp => {
          this.products = {};
          this.isSuccess = true;
          this.status = resp.data.status;
          this.discount = resp.data.discount;
          this.price_total = resp.data.price_total;
          this.total = resp.data.total;
      })
      .catch(Error => function(){
        alert(Error)
      });
       console.log(this.currentSelectedSizes);
    }
  }
}
</script>

<style scoped>

</style>
